# MPI_T_event_handle_alloc

Creates a registration handle for the event type identified by event_index

## Synopsis

    #ifdef ENABLE_QMPI
    #ifndef MPICH_MPI_FROM_PMPI
    int QMPI_T_event_handle_alloc(QMPI_Context context, int tool_id, int event_index, void *obj_handle,
                                  MPI_Info info,
                                  MPI_T_event_registration *event_registration) MPICH_API_PUBLIC

## Input Parameters

event_index
  index of event type for which the registration handle is to be allocated (integer)
obj_handle
  reference to a handle of the mpi object to which this event is supposed to be bound (pointer)
info
  info object (handle)

## Output Parameters

event_registration
  event registration (handle)

## Thread and Interrupt Safety

This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as `malloc` or other non-MPICH runtime routines that are themselves not interrupt-safe.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_ERR_INFO
  Invalid Info

MPI_T_ERR_INVALID
  Invalid use of the interface or bad parameter values(s).

MPI_T_ERR_INVALID_INDEX
  Index is invalid or has been deleted.

MPI_T_ERR_NOT_INITIALIZED
  The MPI tool information interface is not initialized.

MPI_ERR_OTHER
  Other error; use `MPI_Error_string` to get more information about this error code.